# SoVRMLCylinder Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLCylinder.h>`

Inheritance diagram for SoVRMLCylinder:

List of all members.

## Detailed Description

The SoVRMLCylinder class is used to represent a cylinder object.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      Cylinder {
        field    SFBool    bottom  TRUE
        field    SFFloat   height  2         # (0,)
        field    SFFloat   radius  1         # (0,)
        field    SFBool    side    TRUE
        field    SFBool    top     TRUE
      }

The Cylinder node specifies a capped cylinder centred at (0,0,0) in the local coordinate system and with a central axis oriented along the local Y-axis. By default, the cylinder is sized at "-1" to "+1" in all three dimensions. The radius field specifies the radius of the cylinder and the height field specifies the height of the cylinder along the central axis. Both radius and height shall be greater than zero. Figure 6.4 illustrates the Cylinder node.

The cylinder has three parts: the side, the top (Y = +height/2) and the bottom (Y = -height/2). Each part has an associated SFBool field that indicates whether the part exists (TRUE) or does not exist (FALSE). Parts which do not exist are not rendered and not eligible for intersection tests (e.g., collision detection or sensor activation).

Figure 6.4

When a texture is applied to a cylinder, it is applied differently to the sides, top, and bottom. On the sides, the texture wraps counterclockwise (from above) starting at the back of the cylinder. The texture has a vertical seam at the back, intersecting the X=0 plane. For the top and bottom caps, a circle is cut out of the unit texture squares centred at (0, +/- height/2, 0) with dimensions 2 × radius by 2 × radius. The top texture appears right side up when the top of the cylinder is tilted toward the +Z-axis, and the bottom texture appears right side up when the top of the cylinder is tilted toward the -Z-axis. SoVRMLTextureTransform affects the texture coordinates of the Cylinder node. The Cylinder node's geometry requires outside faces only. When viewed from the inside the results are undefined.

## Public Member Functions

| SoVRMLCylinder (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFFloat | radius
SoSFFloat | height
SoSFBool | side
SoSFBool | top
SoSFBool | bottom

## Protected Member Functions

virtual | ~SoVRMLCylinder ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Constructor & Destructor Documentation

SoVRMLCylinder::SoVRMLCylinder | ( | void |  | ) |

| Constructor.

SoVRMLCylinder::~SoVRMLCylinder | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLCylinder::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLGeometry.

void SoVRMLCylinder::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoVRMLCylinder::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoVRMLCylinder::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoVRMLCylinder::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoVRMLCylinder::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## Member Data Documentation

SoSFFloat SoVRMLCylinder::radius

| The cylinder radius. Default value is 1.0.

SoSFFloat SoVRMLCylinder::height

| The cylinder height. Default value is 2.0.

SoSFBool SoVRMLCylinder::side

| Enable/disable the cylinder side wall. Default value is TRUE.

SoSFBool SoVRMLCylinder::top

| Enable/disable the cylinder top. Default value is TRUE.

SoSFBool SoVRMLCylinder::bottom

| Enable/disable the cylinder bottom. Default value is TRUE.

The documentation for this class was generated from the following files:

- SoVRMLCylinder.h
- Cylinder.cpp